Package org.apache.activemq.artemis.api.core.management

## Interface QueueControl

-     public interface QueueControl

  A QueueControl is used to manage a queue.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static java.lang.String` | `CONSUMER_COUNT_DESCRIPTION` |
    `static java.lang.String` | `DELIVERING_MESSAGE_COUNT_DESCRIPTION` |
    `static java.lang.String` | `DELIVERING_SIZE_DESCRIPTION` |
    `static java.lang.String` | `DURABLE_DELIVERING_MESSAGE_COUNT_DESCRIPTION` |
    `static java.lang.String` | `DURABLE_DELIVERING_SIZE_DESCRIPTION` |
    `static java.lang.String` | `DURABLE_MESSAGE_COUNT_DESCRIPTION` |
    `static java.lang.String` | `DURABLE_PERSISTENT_SIZE_DESCRIPTION` |
    `static java.lang.String` | `DURABLE_SCHEDULED_MESSAGE_COUNT_DESCRIPTION` |
    `static java.lang.String` | `DURABLE_SCHEDULED_SIZE_DESCRIPTION` |
    `static java.lang.String` | `MESSAGE_COUNT_DESCRIPTION` |
    `static java.lang.String` | `MESSAGES_ACKNOWLEDGED_DESCRIPTION` |
    `static java.lang.String` | `MESSAGES_ADDED_DESCRIPTION` |
    `static java.lang.String` | `MESSAGES_EXPIRED_DESCRIPTION` |
    `static java.lang.String` | `MESSAGES_KILLED_DESCRIPTION` |
    `static java.lang.String` | `PERSISTENT_SIZE_DESCRIPTION` |
    `static java.lang.String` | `SCHEDULED_MESSAGE_COUNT_DESCRIPTION` |
    `static java.lang.String` | `SCHEDULED_SIZE_DESCRIPTION` |

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Deprecated Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `javax.management.openmbean.CompositeData[]` | `browse()` |
    `javax.management.openmbean.CompositeData[]` | `browse​(int page, int pageSize)` |
    `javax.management.openmbean.CompositeData[]` | `browse​(int page, int pageSize, java.lang.String filter)` |
    `javax.management.openmbean.CompositeData[]` | `browse​(java.lang.String filter)` |
    `boolean` | `changeMessagePriority​(long messageID, int newPriority)` | Changes the message's priority corresponding to the specified message ID to the specified priority.
    `int` | `changeMessagesPriority​(java.lang.String filter, int newPriority)` | Changes the priority for all the message corresponding to the specified filter to the specified priority.
    `long` | `countDeliveringMessages​(java.lang.String filter)` | Counts the number of delivering messages in this queue matching the specified filter.
    `java.lang.String` | `countDeliveringMessages​(java.lang.String filter, java.lang.String groupByProperty)` | Counts the number of delivering messages in this queue matching the specified filter, grouped by the given property field.
    `long` | `countMessages()` |
    `long` | `countMessages​(java.lang.String filter)` | Counts the number of messages in this queue matching the specified filter.
    `java.lang.String` | `countMessages​(java.lang.String filter, java.lang.String groupByProperty)` | Counts the number of messages in this queue matching the specified filter, grouped by the given property field.
    `void` | `disable()` | Enables the queue.
    `void` | `enable()` | Enables the queue.
    `boolean` | `expireMessage​(long messageID)` | Expires the message corresponding to the specified message ID.
    `int` | `expireMessages​(java.lang.String filter)` | Expires all the message corresponding to the specified filter.
    `void` | `flushExecutor()` | it will flush one cycle on internal executors, so you would be sure that any pending tasks are done before you call any other measure.
    `long` | `getAcknowledgeAttempts()` | Returns the number of messages added to this queue since it was created.
    `java.lang.String` | `getAddress()` | Returns the address this queue is bound to.
    `int` | `getConsumerCount()` | Returns the number of consumers consuming messages from this queue.
    `int` | `getConsumersBeforeDispatch()` | Return the Consumers Before Dispatch
    `java.lang.String` | `getDeadLetterAddress()` | Returns the dead-letter address associated with this queue.
    `long` | `getDelayBeforeDispatch()` | Return the Consumers Before Dispatch
    `int` | `getDeliveringCount()` | Returns the number of messages that this queue is currently delivering to its consumers.
    `long` | `getDeliveringSize()` | Returns the persistent size of messages that this queue is currently delivering to its consumers.
    `int` | `getDurableDeliveringCount()` | Returns the number of durable messages that this queue is currently delivering to its consumers.
    `long` | `getDurableDeliveringSize()` | Returns the size of durable messages that this queue is currently delivering to its consumers.
    `long` | `getDurableMessageCount()` | Returns the number of durable messages currently in this queue.
    `long` | `getDurablePersistentSize()` | Returns the persistent size of durable messages currently in this queue.
    `long` | `getDurableScheduledCount()` | Returns the number of durable scheduled messages in this queue.
    `long` | `getDurableScheduledSize()` | Returns the size of durable scheduled messages in this queue.
    `java.lang.String` | `getExpiryAddress()` | Returns the expiry address associated with this queue.
    `java.lang.String` | `getFilter()` | Returns the filter associated with this queue.
    `java.lang.Long` | `getFirstMessageAge()` | Returns the age of the first message in milliseconds.
    `java.lang.String` | `getFirstMessageAsJSON()` | Returns the first message on the queue as JSON
    `java.lang.Long` | `getFirstMessageTimestamp()` | Returns the timestamp of the first message in milliseconds.
    `int` | `getGroupBuckets()` | Will return the group buckets.
    `int` | `getGroupCount()` | Will return the current number of active groups.
    `java.lang.String` | `getGroupFirstKey()` | Will return the header key to notify a consumer of a group change.
    `long` | `getID()` | Returns this queue ID.
    `java.lang.String` | `getLastValueKey()` | The key used for the last value queues
    `int` | `getMaxConsumers()` |
    `long` | `getMessageCount()` | Returns the number of messages currently in this queue.
    `long` | `getMessagesAcknowledged()` | Returns the number of messages added to this queue since it was created.
    `long` | `getMessagesAdded()` | Returns the number of messages added to this queue since it was created.
    `long` | `getMessagesExpired()` | Returns the number of messages expired from this queue since it was created.
    `long` | `getMessagesKilled()` | Returns the number of messages removed from this queue since it was created due to exceeding the max delivery attempts.
    `java.lang.String` | `getName()` | Returns the name of this queue.
    `long` | `getPersistentSize()` | Returns the persistent size of all messages currently in this queue.
    `int` | `getPreparedTransactionMessageCount()` | Will return the number of messages stuck in prepared transactions
    `long` | `getRingSize()` | Will return the ring size.
    `java.lang.String` | `getRoutingType()` | The routing type of this queue.
    `long` | `getScheduledCount()` | Returns the number of scheduled messages in this queue.
    `long` | `getScheduledSize()` | Returns the size of scheduled messages in this queue.
    `java.lang.String` | `getUser()` | Returns the user that is associated with creating the queue.
    `boolean` | `isConfigurationManaged()` |
    `boolean` | `isDurable()` | Returns whether this queue is durable.
    `boolean` | `isEnabled()` |
    `boolean` | `isExclusive()` |
    `boolean` | `isGroupRebalance()` | Returns whether the groups of this queue are automatically rebalanced.
    `boolean` | `isGroupRebalancePauseDispatch()` | Returns whether the dispatch is paused when groups of this queue are automatically rebalanced.
    `boolean` | `isLastValue()` |
    `boolean` | `isPaused()` | Returns whether the queue is paused.
    `boolean` | `isPurgeOnNoConsumers()` |
    `boolean` | `isRetroactiveResource()` | Returns whether this queue is used for a retroactive address.
    `boolean` | `isTemporary()` | Returns whether this queue is temporary.
    `java.lang.String` | `listConsumersAsJSON()` |
    `java.util.Map<java.lang.String,​java.util.Map<java.lang.String,​java.lang.Object>[]>` | `listDeliveringMessages()` | Lists all the messages being deliver per consumer.
    `java.lang.String` | `listDeliveringMessagesAsJSON()` | Executes a conversion of `listDeliveringMessages()` to JSON
    `java.lang.String` | `listGroupsAsJSON()` |
    `java.lang.String` | `listMessageCounter()` | Lists the message counter for this queue.
    `java.lang.String` | `listMessageCounterAsHTML()` | Lists the message counter for this queue as a HTML table.
    `java.lang.String` | `listMessageCounterHistory()` | Lists the message counter history for this queue.
    `java.lang.String` | `listMessageCounterHistoryAsHTML()` | Deprecated.
    `java.util.Map<java.lang.String,​java.lang.Object>[]` | `listMessages​(java.lang.String filter)` | Lists all the messages in this queue matching the specified filter.
    `java.lang.String` | `listMessagesAsJSON​(java.lang.String filter)` | Lists all the messages in this queue matching the specified filter using JSON serialization.
    `java.util.Map<java.lang.String,​java.lang.Object>[]` | `listScheduledMessages()` | Lists all the messages scheduled for delivery for this queue.
    `java.lang.String` | `listScheduledMessagesAsJSON()` | Lists all the messages scheduled for delivery for this queue using JSON serialization.
    `boolean` | `moveMessage​(long messageID, java.lang.String otherQueueName)` | Moves the message corresponding to the specified message ID to the specified other queue.
    `boolean` | `moveMessage​(long messageID, java.lang.String otherQueueName, boolean rejectDuplicates)` | Moves the message corresponding to the specified message ID to the specified other queue.
    `int` | `moveMessages​(int flushLimit, java.lang.String filter, java.lang.String otherQueueName, boolean rejectDuplicates)` |
    `int` | `moveMessages​(int flushLimit, java.lang.String filter, java.lang.String otherQueueName, boolean rejectDuplicates, int messageCount)` |
    `int` | `moveMessages​(java.lang.String filter, java.lang.String otherQueueName)` | Moves all the message corresponding to the specified filter to the specified other queue.
    `int` | `moveMessages​(java.lang.String filter, java.lang.String otherQueueName, boolean rejectDuplicates)` | Moves all the message corresponding to the specified filter to the specified other queue.
    `void` | `pause()` | Pauses the queue.
    `void` | `pause​(boolean persist)` | Pauses the queue.
    `int` | `removeAllMessages()` | Removes all the message from the queue.
    `boolean` | `removeMessage​(long messageID)` | Removes the message corresponding to the specified message ID.
    `int` | `removeMessages​(int flushLimit, java.lang.String filter)` | Removes all the message corresponding to the specified filter.
    `int` | `removeMessages​(java.lang.String filter)` | Removes all the message corresponding to the specified filter.
    `void` | `resetAllGroups()` | Will reset the all the groups.
    `void` | `resetGroup​(java.lang.String groupID)` | Will reset the group matching the given groupID.
    `void` | `resetMessageCounter()` | Resets the message counter for this queue.
    `void` | `resetMessagesAcknowledged()` | Resets the MessagesAdded property
    `void` | `resetMessagesAdded()` | Resets the MessagesAdded property
    `void` | `resetMessagesExpired()` | Resets the MessagesExpired property
    `void` | `resetMessagesKilled()` | Resets the MessagesExpired property
    `void` | `resume()` | Resumes the queue.
    `boolean` | `retryMessage​(long messageID)` | Retries the message corresponding to the given messageID to the original queue.
    `int` | `retryMessages()` | Retries all messages on a DLQ to their respective original queues.
    `java.lang.String` | `sendMessage​(java.util.Map<java.lang.String,​java.lang.String> headers, int type, java.lang.String body, boolean durable, java.lang.String user, java.lang.String password)` |
    `java.lang.String` | `sendMessage​(java.util.Map<java.lang.String,​java.lang.String> headers, int type, java.lang.String body, boolean durable, java.lang.String user, java.lang.String password, boolean createMessageId)` |
    `int` | `sendMessagesToDeadLetterAddress​(java.lang.String filterStr)` | Sends all the message corresponding to the specified filter to this queue's dead letter address.
    `boolean` | `sendMessageToDeadLetterAddress​(long messageID)` | Sends the message corresponding to the specified message ID to this queue's dead letter address.

- - ### Field Detail

    - #### MESSAGE_COUNT_DESCRIPTION

          static final java.lang.String MESSAGE_COUNT_DESCRIPTION

      See Also:
        Constant Field Values

    - #### DURABLE_MESSAGE_COUNT_DESCRIPTION

          static final java.lang.String DURABLE_MESSAGE_COUNT_DESCRIPTION

      See Also:
        Constant Field Values

    - #### PERSISTENT_SIZE_DESCRIPTION

          static final java.lang.String PERSISTENT_SIZE_DESCRIPTION

      See Also:
        Constant Field Values

    - #### DURABLE_PERSISTENT_SIZE_DESCRIPTION

          static final java.lang.String DURABLE_PERSISTENT_SIZE_DESCRIPTION

      See Also:
        Constant Field Values

    - #### SCHEDULED_MESSAGE_COUNT_DESCRIPTION

          static final java.lang.String SCHEDULED_MESSAGE_COUNT_DESCRIPTION

      See Also:
        Constant Field Values

    - #### DURABLE_SCHEDULED_MESSAGE_COUNT_DESCRIPTION

          static final java.lang.String DURABLE_SCHEDULED_MESSAGE_COUNT_DESCRIPTION

      See Also:
        Constant Field Values

    - #### SCHEDULED_SIZE_DESCRIPTION

          static final java.lang.String SCHEDULED_SIZE_DESCRIPTION

      See Also:
        Constant Field Values

    - #### DURABLE_SCHEDULED_SIZE_DESCRIPTION

          static final java.lang.String DURABLE_SCHEDULED_SIZE_DESCRIPTION

      See Also:
        Constant Field Values

    - #### DELIVERING_MESSAGE_COUNT_DESCRIPTION

          static final java.lang.String DELIVERING_MESSAGE_COUNT_DESCRIPTION

      See Also:
        Constant Field Values

    - #### DURABLE_DELIVERING_MESSAGE_COUNT_DESCRIPTION

          static final java.lang.String DURABLE_DELIVERING_MESSAGE_COUNT_DESCRIPTION

      See Also:
        Constant Field Values

    - #### DELIVERING_SIZE_DESCRIPTION

          static final java.lang.String DELIVERING_SIZE_DESCRIPTION

      See Also:
        Constant Field Values

    - #### DURABLE_DELIVERING_SIZE_DESCRIPTION

          static final java.lang.String DURABLE_DELIVERING_SIZE_DESCRIPTION

      See Also:
        Constant Field Values

    - #### CONSUMER_COUNT_DESCRIPTION

          static final java.lang.String CONSUMER_COUNT_DESCRIPTION

      See Also:
        Constant Field Values

    - #### MESSAGES_ADDED_DESCRIPTION

          static final java.lang.String MESSAGES_ADDED_DESCRIPTION

      See Also:
        Constant Field Values

    - #### MESSAGES_ACKNOWLEDGED_DESCRIPTION

          static final java.lang.String MESSAGES_ACKNOWLEDGED_DESCRIPTION

      See Also:
        Constant Field Values

    - #### MESSAGES_EXPIRED_DESCRIPTION

          static final java.lang.String MESSAGES_EXPIRED_DESCRIPTION

      See Also:
        Constant Field Values

    - #### MESSAGES_KILLED_DESCRIPTION

          static final java.lang.String MESSAGES_KILLED_DESCRIPTION

      See Also:
        Constant Field Values

  - ### Method Detail

    - #### getName

          java.lang.String getName()

      Returns the name of this queue.

    - #### getAddress

          java.lang.String getAddress()

      Returns the address this queue is bound to.

    - #### getID

          long getID()

      Returns this queue ID.

    - #### isTemporary

          boolean isTemporary()

      Returns whether this queue is temporary.

    - #### isRetroactiveResource

          boolean isRetroactiveResource()

      Returns whether this queue is used for a retroactive address.

    - #### isDurable

          boolean isDurable()

      Returns whether this queue is durable.

    - #### getUser

          java.lang.String getUser()

      Returns the user that is associated with creating the queue.

    - #### getRoutingType

          java.lang.String getRoutingType()

      The routing type of this queue.

    - #### getFilter

          java.lang.String getFilter()

      Returns the filter associated with this queue.

    - #### getMessageCount

          long getMessageCount()

      Returns the number of messages currently in this queue.

    - #### getPersistentSize

          long getPersistentSize()

      Returns the persistent size of all messages currently in this queue. The persistent size of a message is the amount of space the message would take up on disk which is used to track how much data there is to consume on this queue

    - #### getDurableMessageCount

          long getDurableMessageCount()

      Returns the number of durable messages currently in this queue.

    - #### getDurablePersistentSize

          long getDurablePersistentSize()

      Returns the persistent size of durable messages currently in this queue. The persistent size of a message is the amount of space the message would take up on disk which is used to track how much data there is to consume on this queue

    - #### getScheduledCount

          long getScheduledCount()

      Returns the number of scheduled messages in this queue.

    - #### getScheduledSize

          long getScheduledSize()

      Returns the size of scheduled messages in this queue.

    - #### getDurableScheduledCount

          long getDurableScheduledCount()

      Returns the number of durable scheduled messages in this queue.

    - #### getDurableScheduledSize

          long getDurableScheduledSize()

      Returns the size of durable scheduled messages in this queue.

    - #### getConsumerCount

          int getConsumerCount()

      Returns the number of consumers consuming messages from this queue.

    - #### getDeliveringCount

          int getDeliveringCount()

      Returns the number of messages that this queue is currently delivering to its consumers.

    - #### getDeliveringSize

          long getDeliveringSize()

      Returns the persistent size of messages that this queue is currently delivering to its consumers.

    - #### getDurableDeliveringCount

          int getDurableDeliveringCount()

      Returns the number of durable messages that this queue is currently delivering to its consumers.

    - #### getDurableDeliveringSize

          long getDurableDeliveringSize()

      Returns the size of durable messages that this queue is currently delivering to its consumers.

    - #### getMessagesAdded

          long getMessagesAdded()

      Returns the number of messages added to this queue since it was created.

    - #### getMessagesAcknowledged

          long getMessagesAcknowledged()

      Returns the number of messages added to this queue since it was created.

    - #### getAcknowledgeAttempts

          long getAcknowledgeAttempts()

      Returns the number of messages added to this queue since it was created.

    - #### getMessagesExpired

          long getMessagesExpired()

      Returns the number of messages expired from this queue since it was created.

    - #### getMessagesKilled

          long getMessagesKilled()

      Returns the number of messages removed from this queue since it was created due to exceeding the max delivery attempts.

    - #### getFirstMessageAsJSON

          java.lang.String getFirstMessageAsJSON()
                                          throws java.lang.Exception

      Returns the first message on the queue as JSON
      Throws:
        `java.lang.Exception`

    - #### getFirstMessageTimestamp

          java.lang.Long getFirstMessageTimestamp()
                                           throws java.lang.Exception

      Returns the timestamp of the first message in milliseconds.
      Throws:
        `java.lang.Exception`

    - #### getFirstMessageAge

          java.lang.Long getFirstMessageAge()
                                     throws java.lang.Exception

      Returns the age of the first message in milliseconds.
      Throws:
        `java.lang.Exception`

    - #### getExpiryAddress

          java.lang.String getExpiryAddress()

      Returns the expiry address associated with this queue.

    - #### getDeadLetterAddress

          java.lang.String getDeadLetterAddress()

      Returns the dead-letter address associated with this queue.

    - #### getMaxConsumers

          int getMaxConsumers()

    - #### isPurgeOnNoConsumers

          boolean isPurgeOnNoConsumers()

    - #### isEnabled

          boolean isEnabled()

    - #### enable

          void enable()
               throws java.lang.Exception

      Enables the queue. Messages are now routed to this queue.
      Throws:
        `java.lang.Exception`

    - #### disable

          void disable()
                throws java.lang.Exception

      Enables the queue. Messages are not routed to this queue.
      Throws:
        `java.lang.Exception`

    - #### isConfigurationManaged

          boolean isConfigurationManaged()

    - #### isExclusive

          boolean isExclusive()

    - #### isLastValue

          boolean isLastValue()

    - #### getLastValueKey

          java.lang.String getLastValueKey()

      The key used for the last value queues

    - #### getConsumersBeforeDispatch

          int getConsumersBeforeDispatch()

      Return the Consumers Before Dispatch
      Returns:

    - #### getDelayBeforeDispatch

          long getDelayBeforeDispatch()

      Return the Consumers Before Dispatch
      Returns:

    - #### listScheduledMessages

          java.util.Map<java.lang.String,​java.lang.Object>[] listScheduledMessages()
                                                                                  throws java.lang.Exception

      Lists all the messages scheduled for delivery for this queue.
      1 Map represents 1 message, keys are the message's properties and headers, values are the corresponding values.
      Throws:
        `java.lang.Exception`

    - #### listScheduledMessagesAsJSON

          java.lang.String listScheduledMessagesAsJSON()
                                                throws java.lang.Exception

      Lists all the messages scheduled for delivery for this queue using JSON serialization.
      Throws:
        `java.lang.Exception`

    - #### listDeliveringMessages

          java.util.Map<java.lang.String,​java.util.Map<java.lang.String,​java.lang.Object>[]> listDeliveringMessages()
                                                                                                                         throws java.lang.Exception

      Lists all the messages being deliver per consumer.
      The Map's key is a toString representation for the consumer. Each consumer will then return a `Map<String,Object>[]` same way is returned by `listScheduledMessages()`
      Throws:
        `java.lang.Exception`

    - #### listDeliveringMessagesAsJSON

          java.lang.String listDeliveringMessagesAsJSON()
                                                 throws java.lang.Exception

      Executes a conversion of `listDeliveringMessages()` to JSON
      Returns:
      Throws:
        `java.lang.Exception`

    - #### listMessages

          java.util.Map<java.lang.String,​java.lang.Object>[] listMessages​(java.lang.String filter)
                                                                         throws java.lang.Exception

      Lists all the messages in this queue matching the specified filter.
      1 Map represents 1 message, keys are the message's properties and headers, values are the corresponding values.
      Using `null` or an empty filter will list all messages from this queue.
      Throws:
        `java.lang.Exception`

    - #### listMessagesAsJSON

          java.lang.String listMessagesAsJSON​(java.lang.String filter)
                                       throws java.lang.Exception

      Lists all the messages in this queue matching the specified filter using JSON serialization.
      Using `null` or an empty filter will list all messages from this queue.
      Throws:
        `java.lang.Exception`

    - #### countMessages

          long countMessages​(java.lang.String filter)
                      throws java.lang.Exception

      Counts the number of messages in this queue matching the specified filter.
      Using `null` or an empty filter will count all messages from this queue.
      Throws:
        `java.lang.Exception`

    - #### countMessages

          long countMessages()
                      throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### countMessages

          java.lang.String countMessages​(java.lang.String filter,
                                         java.lang.String groupByProperty)
                                  throws java.lang.Exception

      Counts the number of messages in this queue matching the specified filter, grouped by the given property field. In case of null property will be grouped in "null"
      Using `null` or an empty filter will count all messages from this queue.
      Throws:
        `java.lang.Exception`

    - #### countDeliveringMessages

          long countDeliveringMessages​(java.lang.String filter)
                                throws java.lang.Exception

      Counts the number of delivering messages in this queue matching the specified filter.
      Using `null` or an empty filter will count all messages from this queue.
      Throws:
        `java.lang.Exception`

    - #### countDeliveringMessages

          java.lang.String countDeliveringMessages​(java.lang.String filter,
                                                   java.lang.String groupByProperty)
                                            throws java.lang.Exception

      Counts the number of delivering messages in this queue matching the specified filter, grouped by the given property field. In case of null property will be grouped in "null"
      Using `null` or an empty filter will count all messages from this queue.
      Throws:
        `java.lang.Exception`

    - #### removeMessage

          boolean removeMessage​(long messageID)
                         throws java.lang.Exception

      Removes the message corresponding to the specified message ID.
      Returns:
        `true` if the message was removed, `false` else
      Throws:
        `java.lang.Exception`

    - #### removeMessages

          int removeMessages​(java.lang.String filter)
                      throws java.lang.Exception

      Removes all the message corresponding to the specified filter.
      Using `null` or an empty filter will remove all messages from this queue.
      Returns:
        the number of removed messages
      Throws:
        `java.lang.Exception`

    - #### removeMessages

          int removeMessages​(int flushLimit,
                             java.lang.String filter)
                      throws java.lang.Exception

      Removes all the message corresponding to the specified filter.
      Using `null` or an empty filter will remove all messages from this queue.
      Returns:
        the number of removed messages
      Throws:
        `java.lang.Exception`

    - #### removeAllMessages

          int removeAllMessages()
                         throws java.lang.Exception

      Removes all the message from the queue.
      Returns:
        the number of removed messages
      Throws:
        `java.lang.Exception`

    - #### expireMessages

          int expireMessages​(java.lang.String filter)
                      throws java.lang.Exception

      Expires all the message corresponding to the specified filter.
      Using `null` or an empty filter will expire all messages from this queue.
      Returns:
        the number of expired messages
      Throws:
        `java.lang.Exception`

    - #### expireMessage

          boolean expireMessage​(long messageID)
                         throws java.lang.Exception

      Expires the message corresponding to the specified message ID.
      Returns:
        `true` if the message was expired, `false` else
      Throws:
        `java.lang.Exception`

    - #### retryMessage

          boolean retryMessage​(long messageID)
                        throws java.lang.Exception

      Retries the message corresponding to the given messageID to the original queue. This is appropriate on dead messages on Dead letter queues only.
      Parameters:
        `messageID` -
      Returns:
        `true` if the message was retried, `false` else
      Throws:
        `java.lang.Exception`

    - #### retryMessages

          int retryMessages()
                     throws java.lang.Exception

      Retries all messages on a DLQ to their respective original queues. This is appropriate on dead messages on Dead letter queues only.
      Returns:
        the number of retried messages.
      Throws:
        `java.lang.Exception`

    - #### moveMessage

          boolean moveMessage​(long messageID,
                              java.lang.String otherQueueName)
                       throws java.lang.Exception

      Moves the message corresponding to the specified message ID to the specified other queue.
      Returns:
        `true` if the message was moved, `false` else
      Throws:
        `java.lang.Exception`

    - #### moveMessage

          boolean moveMessage​(long messageID,
                              java.lang.String otherQueueName,
                              boolean rejectDuplicates)
                       throws java.lang.Exception

      Moves the message corresponding to the specified message ID to the specified other queue.
      Returns:
        `true` if the message was moved, `false` else
      Throws:
        `java.lang.Exception`

    - #### moveMessages

          int moveMessages​(java.lang.String filter,
                           java.lang.String otherQueueName)
                    throws java.lang.Exception

      Moves all the message corresponding to the specified filter to the specified other queue. RejectDuplicates = false on this case
      Using `null` or an empty filter will move all messages from this queue.
      Returns:
        the number of moved messages
      Throws:
        `java.lang.Exception`

    - #### moveMessages

          int moveMessages​(java.lang.String filter,
                           java.lang.String otherQueueName,
                           boolean rejectDuplicates)
                    throws java.lang.Exception

      Moves all the message corresponding to the specified filter to the specified other queue.
      Using `null` or an empty filter will move all messages from this queue.
      Returns:
        the number of moved messages
      Throws:
        `java.lang.Exception`

    - #### moveMessages

          int moveMessages​(int flushLimit,
                           java.lang.String filter,
                           java.lang.String otherQueueName,
                           boolean rejectDuplicates)
                    throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### moveMessages

          int moveMessages​(int flushLimit,
                           java.lang.String filter,
                           java.lang.String otherQueueName,
                           boolean rejectDuplicates,
                           int messageCount)
                    throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### sendMessageToDeadLetterAddress

          boolean sendMessageToDeadLetterAddress​(long messageID)
                                          throws java.lang.Exception

      Sends the message corresponding to the specified message ID to this queue's dead letter address.
      Returns:
        `true` if the message was sent to the dead letter address, `false` else
      Throws:
        `java.lang.Exception`

    - #### sendMessagesToDeadLetterAddress

          int sendMessagesToDeadLetterAddress​(java.lang.String filterStr)
                                       throws java.lang.Exception

      Sends all the message corresponding to the specified filter to this queue's dead letter address.
      Using `null` or an empty filter will send all messages from this queue.
      Returns:
        the number of sent messages
      Throws:
        `java.lang.Exception`

    - #### sendMessage

          java.lang.String sendMessage​(java.util.Map<java.lang.String,​java.lang.String> headers,
                                       int type,
                                       java.lang.String body,
                                       boolean durable,
                                       java.lang.String user,
                                       java.lang.String password)
                                throws java.lang.Exception

      Parameters:
        `headers` - the message headers and properties to set. Can only container Strings maped to primitive types.
        `body` - the text to send
        `durable` -
        `user` -
        `password` -
      Returns:
      Throws:
        `java.lang.Exception`

    - #### sendMessage

          java.lang.String sendMessage​(java.util.Map<java.lang.String,​java.lang.String> headers,
                                       int type,
                                       java.lang.String body,
                                       boolean durable,
                                       java.lang.String user,
                                       java.lang.String password,
                                       boolean createMessageId)
                                throws java.lang.Exception

      Parameters:
        `headers` - the message headers and properties to set. Can only container Strings maped to primitive types.
        `body` - the text to send
        `durable` -
        `user` -
        `password` -
        `createMessageId` - whether or not to auto generate a Message ID
      Returns:
      Throws:
        `java.lang.Exception`

    - #### changeMessagePriority

          boolean changeMessagePriority​(long messageID,
                                        int newPriority)
                                 throws java.lang.Exception

      Changes the message's priority corresponding to the specified message ID to the specified priority.
      Parameters:
        `newPriority` - between 0 and 9 inclusive.
      Returns:
        `true` if the message priority was changed
      Throws:
        `java.lang.Exception`

    - #### changeMessagesPriority

          int changeMessagesPriority​(java.lang.String filter,
                                     int newPriority)
                              throws java.lang.Exception

      Changes the priority for all the message corresponding to the specified filter to the specified priority.
      Using `null` or an empty filter will change all messages from this queue.
      Returns:
        the number of changed messages
      Throws:
        `java.lang.Exception`

    - #### listMessageCounter

          java.lang.String listMessageCounter()
                                       throws java.lang.Exception

      Lists the message counter for this queue.
      Throws:
        `java.lang.Exception`

    - #### resetMessageCounter

          void resetMessageCounter()
                            throws java.lang.Exception

      Resets the message counter for this queue.
      Throws:
        `java.lang.Exception`

    - #### listMessageCounterAsHTML

          java.lang.String listMessageCounterAsHTML()
                                             throws java.lang.Exception

      Lists the message counter for this queue as a HTML table.
      Throws:
        `java.lang.Exception`

    - #### listMessageCounterHistory

          java.lang.String listMessageCounterHistory()
                                              throws java.lang.Exception

      Lists the message counter history for this queue.
      Throws:
        `java.lang.Exception`

    - #### listMessageCounterHistoryAsHTML

          @Deprecated
          java.lang.String listMessageCounterHistoryAsHTML()
                                                    throws java.lang.Exception

      Deprecated.
      Lists the message counter history for this queue as a HTML table.
      Throws:
        `java.lang.Exception`

    - #### pause

          void pause()
              throws java.lang.Exception

      Pauses the queue. Messages are no longer delivered to its consumers.
      Throws:
        `java.lang.Exception`

    - #### pause

          void pause​(boolean persist)
              throws java.lang.Exception

      Pauses the queue. Messages are no longer delivered to its consumers.
      Throws:
        `java.lang.Exception`

    - #### resume

          void resume()
               throws java.lang.Exception

      Resumes the queue. Messages are again delivered to its consumers.
      Throws:
        `java.lang.Exception`

    - #### listConsumersAsJSON

          java.lang.String listConsumersAsJSON()
                                        throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### isPaused

          boolean isPaused()
                    throws java.lang.Exception

      Returns whether the queue is paused.
      Throws:
        `java.lang.Exception`

    - #### browse

          javax.management.openmbean.CompositeData[] browse()
                                                     throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### browse

          javax.management.openmbean.CompositeData[] browse​(java.lang.String filter)
                                                     throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### browse

          javax.management.openmbean.CompositeData[] browse​(int page,
                                                            int pageSize)
                                                     throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### browse

          javax.management.openmbean.CompositeData[] browse​(int page,
                                                            int pageSize,
                                                            java.lang.String filter)
                                                     throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### resetMessagesAdded

          void resetMessagesAdded()
                           throws java.lang.Exception

      Resets the MessagesAdded property
      Throws:
        `java.lang.Exception`

    - #### resetMessagesAcknowledged

          void resetMessagesAcknowledged()
                                  throws java.lang.Exception

      Resets the MessagesAdded property
      Throws:
        `java.lang.Exception`

    - #### resetMessagesExpired

          void resetMessagesExpired()
                             throws java.lang.Exception

      Resets the MessagesExpired property
      Throws:
        `java.lang.Exception`

    - #### resetMessagesKilled

          void resetMessagesKilled()
                            throws java.lang.Exception

      Resets the MessagesExpired property
      Throws:
        `java.lang.Exception`

    - #### flushExecutor

          void flushExecutor()

      it will flush one cycle on internal executors, so you would be sure that any pending tasks are done before you call any other measure. It is useful if you need the exact number of counts on a message

    - #### resetAllGroups

          void resetAllGroups()

      Will reset the all the groups. This is useful if you want a complete rebalance of the groups to consumers

    - #### resetGroup

          void resetGroup​(java.lang.String groupID)

      Will reset the group matching the given groupID. This is useful if you want the given group to be rebalanced to the consumers

    - #### getGroupCount

          int getGroupCount()

      Will return the current number of active groups.

    - #### listGroupsAsJSON

          java.lang.String listGroupsAsJSON()
                                     throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### getRingSize

          long getRingSize()

      Will return the ring size.

    - #### isGroupRebalance

          boolean isGroupRebalance()

      Returns whether the groups of this queue are automatically rebalanced.

    - #### isGroupRebalancePauseDispatch

          boolean isGroupRebalancePauseDispatch()

      Returns whether the dispatch is paused when groups of this queue are automatically rebalanced.

    - #### getGroupBuckets

          int getGroupBuckets()

      Will return the group buckets.

    - #### getGroupFirstKey

          java.lang.String getGroupFirstKey()

      Will return the header key to notify a consumer of a group change.

    - #### getPreparedTransactionMessageCount

          int getPreparedTransactionMessageCount()

      Will return the number of messages stuck in prepared transactions